package ${packageName};

import org.springframework.stereotype.Component;

import pro.shushi.pamirs.meta.annotation.Fun;
import pro.shushi.pamirs.meta.annotation.Function;

import ${apiPackageName}.${modelService};
import ${modelPackageName}.${model};

/*
 * 实现类上必须@Fun才能在分布式下自动向注册中心注册服务
 * 方法上加@Function，方法才能被真正调用到
 */
@Fun(${modelService}.FUN_NAMESPACE)
@Component
public class ${modelService}Impl implements ${modelService} {

    private void check(${model} record){
        //公共处理逻辑，基础检验工作

    }

    @Override
    @Function
    public ${model} create(${model} record) {
        //基础检验
        check(record);
        //默认值设置
        record.construct();
        //创建记录
        record = record.create();
        //创建后需要做什么，对关联对象进行保存 eg： record.fieldSave(${model}::getXXX);

        return record;
    }

    @Override
    @Function
    public ${model} update(${model} record) {
        //基础检验
        check(record);
        //更新
        int i = record.updateById();
        if(i!=1){
            throw new RuntimeException("${model},更新失败");
            //TODO 定义异常枚举  throw PamirsException.construct().errThrow();
        }
        //创建后需要做什么，对关联对象进行保存 eg： record.fieldSave(${model}::getXXX),如果有请加上事务;
        return record;
    }

}
